//
//  main.m
//  PubSubTest
//
//  Created by Sasmito Adibowo on 12-10-11.
//  Copyright (c) 2011 Basil Salad Software. All rights reserved.
//

#import <Cocoa/Cocoa.h>

bool BSCreatePubSubSymlink();


//void BSCreatePubSubSymlink();

bool BSCreatePubSubSymlink()
{
    NSString* libraryDirectory = [NSSearchPathForDirectoriesInDomains(NSLibraryDirectory, NSUserDomainMask, YES) lastObject];
    NSString* pubSubDirectory = [libraryDirectory stringByAppendingPathComponent:@"PubSub"];
    NSString* pubSubTarget = @"../../../../PubSub";
    NSFileManager* fileManager = [NSFileManager defaultManager];
    
    BOOL isDirectory  = NO;
    NSString* realPubSubDirectory = [libraryDirectory stringByAppendingPathComponent:pubSubTarget];
    if ([fileManager fileExistsAtPath:realPubSubDirectory isDirectory:&isDirectory]) {
        if (isDirectory) {
            int success = symlink([pubSubTarget UTF8String], [pubSubDirectory UTF8String]);
            if (success != 0) {
                if (errno != EEXIST) {
                    return NO;
                }
            }
        }
    }    
    return YES;
}

int main(int argc, char *argv[])
{
    NSAutoreleasePool* pool = [NSAutoreleasePool new];

    NSLog(@" *** PubSubTest start *** ");
    
    BSCreatePubSubSymlink();
    
    int resultCode = NSApplicationMain(argc, (const char **)argv);
    [pool drain];    
    return resultCode;
}
